Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_Unbounded_String_Sequence Class Reference

`#include <Sequence.h>`

Inheritance diagram for TAO_Unbounded_String_Sequence

[legend]
Collaboration diagram for TAO_Unbounded_String_Sequence:

[legend]
List of all members.

## Public Methods
| TAO_Unbounded_String_Sequence (void)
| TAO_Unbounded_String_Sequence (CORBA::ULong maximum)
| TAO_Unbounded_String_Sequence (CORBA::ULong maximum, CORBA::ULong length, char **data, CORBA::Boolean release=0)
| TAO_Unbounded_String_Sequence (const TAO_Unbounded_String_Sequence&)
| ~TAO_Unbounded_String_Sequence (void)
| The destructor releases all object reference members and frees all string members.
TAO_Unbounded_String_Sequence& | operator= (const TAO_Unbounded_String_Sequence &)
TAO_SeqElem_String_Manager | operator[] (CORBA::ULong slot) const
| read-write accessor.
char** | get_buffer (CORBA::Boolean orphan = 0)
const char** | get_buffer (void) const
virtual void | _allocate_buffer (CORBA::ULong length)
virtual void | _deallocate_buffer (void)
| Must deallocate the buffer and then set it to zero.
virtual void | _shrink_buffer (CORBA::ULong new_length, CORBA::ULong old_length)
## Static Public Methods
char** | allocbuf (CORBA::ULong)
void | freebuf (char **)

## Detailed Description

=TITLE Unbounded sequence of strings. =DESCRIPTION IDL sequences of strings must automatically duplicate and release their members based on some global <release> flag.

## Constructor & Destructor Documentation

ACE_INLINE TAO_Unbounded_String_Sequence::TAO_Unbounded_String_Sequence ( | void )

| {orbos/97-05-15:16.8} The default constructor initializes object reference members to appropriately typed nil object references and string members to NULL; all other members are initialized via their default constructors. {orbos/97-05-15:16.11} For both bounded and unbounded sequences, the default constructor (as shown in the example above) sets the sequence length equal to 0.

TAO_Unbounded_String_Sequence::TAO_Unbounded_String_Sequence ( | CORBA::ULong maximum )

| Unbounded sequences provide a constructor that allows only the initial value of the maximum length to be set (the ``maximum constructor'' shown in the example above). This allows applications to control how much buffer space is initially allocated by the sequence. This constructor also sets the length to 0 and the release flag to TRUE.

ACE_INLINE TAO_Unbounded_String_Sequence::TAO_Unbounded_String_Sequence ( | CORBA::ULong maximum,
| CORBA::ULong length,
| char ** value,
| CORBA::Boolean release = 0 )

| The ``T *data'' constructor (as shown in the example above) allows the length and contents of a bounded or unbounded sequence to be set. For unbounded sequences, it also allows the initial value of the maximum length to be set. For this constructor, ownership of the contents vector is determined by the release parameter---FALSE means the caller owns the storage, while TRUE means that the sequence assumes ownership of the storage. If release is TRUE, the contents vector must have been allocated using the sequence allocbuf function, and the sequence will pass it to freebuf when finished with it.

TAO_Unbounded_String_Sequence::TAO_Unbounded_String_Sequence ( | const TAO_Unbounded_String_Sequence & rhs )

| The copy constructor performs a deep copy from the existing structure to create a new structure, including calling _duplicate on all object reference members and performing the necessary heap allocations for all string members. The copy constructor creates a new sequence with the same maximum and length as the given sequence, copies each of its current elements (items zero through length-1), and sets the release flag to TRUE.

TAO_Unbounded_String_Sequence::~TAO_Unbounded_String_Sequence ( | void )

| The destructor releases all object reference members and frees all string members.

## Member Function Documentation

void TAO_Unbounded_String_Sequence::_allocate_buffer ( | CORBA::ULong length )`[virtual]`

| Ensure that the buffer contains space for at least <length> elements. The constructor must be called for any new elements, the old ones (if any) must be copied into the buffer using operator= and then their destructors must be called. Finally the old buffer must be released. Reimplemented from TAO_Base_Sequence.

void TAO_Unbounded_String_Sequence::_deallocate_buffer ( | void )`[virtual]`

| Must deallocate the buffer and then set it to zero. Reimplemented from TAO_Base_Sequence.

void TAO_Unbounded_String_Sequence::_shrink_buffer ( | CORBA::ULong nl,
| CORBA::ULong ol )`[virtual]`

| Some sequences (of objects and strings) require some cleanup if the sequence is shrunk. The spec requires the destructor to release the objects only from position <0> to <length-1>; so shrink and then delete could result in a memory leak. Reimplemented from TAO_Base_Sequence.

char ** TAO_Unbounded_String_Sequence::allocbuf ( | CORBA::ULong nelems )`[static]`

| The allocbuf function allocates a vector of T elements that can be passed to the T *data constructor. The length of the vector is given by the nelems function argument. The allocbuf function initializes each element using its default constructor, except for strings, which are initialized to null pointers, and object references, which are initialized to suitably typed nil object references. A null pointer is returned if allocbuf for some reason cannot allocate the requested vector. Vectors allocated by allocbuf should be freed using the freebuf function.

void TAO_Unbounded_String_Sequence::freebuf ( | char ** buffer )`[static]`

| The freebuf function ensures that the destructor for each element is called before the buffer is destroyed, except for string elements, which are freed using string_free(), and object reference elements, which are freed using release(). The freebuf function will ignore null pointers passed to it.

const char ** TAO_Unbounded_String_Sequence::get_buffer ( | void ) const

char ** TAO_Unbounded_String_Sequence::get_buffer ( | CORBA::Boolean orphan = 0 )

TAO_Unbounded_String_Sequence & TAO_Unbounded_String_Sequence::operator= ( | const TAO_Unbounded_String_Sequence & rhs )

| The assignment operator first releases all object reference members and frees all string members, and then performs a deepcopy to create a new structure. The assignment operator deepcopies its parameter, releasing old storage if necessary. It behaves as if the original sequence is destroyed via its destructor and then the source sequence copied using the copy constructor. If release=TRUE, the destructor destroys each of the current elements (items zero through length--1). For an unbounded sequence, if a reallocation is necessary due to a change in the length and the sequence was created using the release=TRUE parameter in its constructor, the sequence will deallocate the old storage. If release is FALSE under these circumstances, old storage will not be freed before the reallocation is performed. After reallocation, the release flag is always set to TRUE.

TAO_SeqElem_String_Manager TAO_Unbounded_String_Sequence::operator[] ( | CORBA::ULong slot ) const

| read-write accessor.

The documentation for this class was generated from the following files:

- Sequence.h
- Sequence.cpp
- Sequence.i